<?php

class RP_Query_Executor
{

    /**
     *
     * @param string $sql_query
     * @param class RP_Credentials $credentials
     * @return array
     * @throws Exception
     */
    public static function execute($sql_query, $credentials = null)
    {
        $transaction = RP_Transaction::get_current_transaction();
        if (!$transaction) {
            $connection = new RP_Connection($credentials);
        } else {
            $connection = $transaction->get_connection();
        }
        $query = $sql_query->get_query();
        $result = $connection->execute_query($query);
        if (!$result) {
            throw new Exception(mysqli_error($connection->getConnection()));
        }
        $i = 0;
        $tab = array();
        while ($row = mysqli_fetch_array ($result)) {
            $tab[$i++] = $row;
        }
        mysqli_free_result($result);
        if (!$transaction) {
            $connection->close();
        }
        return $tab;
    }

    /**
     *
     * @param string $sql_query
     * @param class RP_Credentials $credentials
     * @return integer
     */
    public static function execute_insert($sql_query, $credentials = null)
    {
        RP_Query_Executor::execute_update($sql_query, $credentials);

        $transaction = RP_Transaction::get_current_transaction();
        if (!$transaction) {
            $connection = new RP_Connection($credentials);
        } else {
            $connection = $transaction->get_connection();
        }
        return mysqli_insert_id ($connection->getConnection());
    }

    /**
     *
     * @param string $sql_query
     * @param class RP_Credentials $credentials
     * @return int
     * @throws Exception
     */
    public static function execute_update($sql_query, $credentials = null)
    {
        $transaction = RP_Transaction::get_current_transaction();
        if (!$transaction) {
            $connection = new RP_Connection($credentials);
        } else {
            $connection = $transaction->get_connection();
        }
        $query = $sql_query->get_query();
        $result = $connection->execute_query($query);
        if (!$result) {
            throw new Exception(mysqli_error($connection->getConnection()));
        }
        return mysqli_affected_rows($connection->getConnection());
    }

    /**
     *
     * @param string $sql_query
     * @param class RP_Credentials $credentials
     * @return string
     * @throws Exception
     */
    public static function query_for_string($sql_query, $credentials = null)
    {
        $transaction = RP_Transaction::get_current_transaction();
        if (!$transaction) {
            $connection = new RP_Connection($credentials);
        } else {
            $connection = $transaction->get_connection();
        }
        $result = $connection->execute_query($sql_query->get_query());
        if (!$result) {
            throw new Exception(mysqli_error($connection->getConnection()));
        }
        $row = mysqli_fetch_array($result);
        return $row[0];
    }
}

?>
